// Thomas Grenier - Creatis

function [fx]=EstimateurNaif( X, Xi, h)
// Xi : echantillon des donnes : matrice
// X  : point o raliser l'estimation
// fx : estimation au point X

[nb_Xi, nb_Dim] = size(Xi); 

// profil de la fonction de pondration
function [y]=k_naif(x)
if abs(x) < 1 then
  y = 1/2;
 else
  y = 0;
end
endfunction

fx=0;
for i = 1:nb_Xi,
  x_xi = X  - Xi(i,:);
  dxs = x_xi(1)*x_xi(1)/(h(1)*h(1)) + x_xi(2)*x_xi(2)/(h(2)*h(2));
  dxr = x_xi(3)*x_xi(3)/(h(3)*h(3));
  fx= fx + k_naif( dxs ) * k_naif( dxr );
end

fx = fx / (nb_Xi * h(3));
//fx = fx / (nb_Xi * h(1)* h(2)* h(3));
endfunction
