// Thomas Grenier - Creatis

// Tirage de nb_Yi points suivant la loi Y
nb_Yi = 20;
// mu = 30;
// ec = 5;
// Y = [grand( nb_Yi/2, 1, 'nor', mu, ec);grand( nb_Yi/2, 1, 'nor', mu+20, ec)]; 

// Loi gamma
shape = 5;
scale = 1;
Y = grand( nb_Yi, 1, 'gam', shape, scale); 


// calcul de h0 pour Gauss
alphaR = (4/(3*nb_Yi))^(1/5);
h0 = alphaR * iqr( Y,'r')./1.349 // Pour Gauss


function [y]=k_gauss_1D(x)
  y = exp(-x/2) / sqrt(2*3.14159);
endfunction

function [fx]=Parzen_1D(X,Xi,h)
fx=0;
[nb_Xi,dim]=size(Xi);
for i = 1:nb_Xi,
  x_xi = X  - Xi(i);
  dxr = x_xi / h;
  fx = fx + k_gauss_1D( dxr * dxr );
end
fx = fx / (nb_Xi * h );
endfunction


clf
plot(Y' , zeros(nb_Yi,1)' + 0.02, '+');

res_F = 100;
F = ones( res_F, 1);
//delta = max(Y) - min(Y);
//px=linspace( min(Y)-delta/10, max(Y)+delta/10, res_F);
px=linspace( 0, 20, res_F);
for i=1:res_F,
  F(i) = Parzen_1D( px(i), Y, h0);
end

//deff('[z]=n1d(x)','z=(1/( ec*sqrt(2*3.1415)))*exp(-((x-mu)^2)/(2*ec*ec)) ');
//plot(px, feval(px,n1d),'b' )

deff('[z]=poisson(x)','z=(scale^shape)*x^(shape-1)*exp(-scale*x)/gamma(shape)' );
plot(px, feval(px,poisson),'b' )
  
plot(px,F, 'r');

