clear all;

// Computing Mean and Grad norm is very very long
// set to 1 the values use_Image_dat, use_MeanImage_dat and use_GradOfMeanImage_dat 
// to use previous computation. 
// These 2 results don't depend on the MS values (h, it, nb_Xi, ...)

// basic tuning
nb_Xi = 1000; //500
h= [5 5 30]; // 3 3 15
Threshold_Grad = 20; //30

use_Image_dat = 0;
use_MeanImage_dat = use_Image_dat;
use_GradOfMeanImage_dat = use_MeanImage_dat;


PathToScript    = 'E:\Creatis\Creatis_GIT\Grenier\Projets\Scilab\';
PathToData      =  PathToScript + 'Data\';

//DataFile          =  'Coeur_08.png'; // Threshold_Grad = 60; h= [5 5 30];   nb_Xi = 500;
//DataFile        = 'tingtest_tito512_blur63_5_sd30.png';
//DataFile        = 'R-G-B64_ColorImage_blurred15_1.png'; //';
//DataFile        = 'R-G-B64_ColorImage_blurred15_5.png'; // h= [5 5 30];  Threshold_Grad = 40;
//DataFile        = 'R-G-B64_ColorImage_blurred15_1_sd30_norm.png';
DataFile        = 'R-G-B64_ColorImage_blurred15_3_sd30_norm.png'; // [ 3 3 15] 500 ou [5 5 15] 500
//DataFile        = 'mri_normRGB_blurred63_1_sd10.png';



// Advanced tuning
Trunc_Gauss = 3;
nb_it_max_ms = 20;
eps_ms = 0.1;


DataFile_woext = strsubst(DataFile, strrchr(DataFile,'.'), ""); // DataFile without extension

PathToSavedData = PathToData + DataFile_woext + '_Save_h' + string(h(3)) + '_Xi' + string(nb_Xi);




//////////////////////////////////////////////
function [y]=k_gauss_1D(x)
  y = exp(-x/2) / sqrt(2*3.14159);
endfunction

function [fx]=Parzen_1D_freq(X,Xi,h)
fx=0;
[nb_Xi,dim]=size(Xi);
for i = 1:nb_Xi,
  x_xi = X  - Xi(i,1);
  dxr = x_xi / h;
  fx = fx + Xi(i,2)* k_gauss_1D( dxr * dxr );
end
fx = fx / sum(Xi(:,2)) * h ;

endfunction





///////////////////////////////////////////////////////////////////////////////
// Module Check and load
///////////////////////////////////////////////////////////////////////////////

// MyScript
//if ~isdef('DParzen_GG') then 
    disp('Loading scripts');
    exec(PathToScript + 'DParzen_GG.sci');
    exec(PathToScript + 'GBMS.sci');
    exec(PathToScript + 'Chi2.sci');
    exec(PathToScript + 'PlotImage.sci');
    
    disp('Loading done');
//end;


if (use_Image_dat == 0) then
    disp('** Loading image : ' + DataFile);
    Image = imread(PathToData + DataFile);
    //Image = Image(50:210,30:230,:);
    save(PathToData + DataFile_woext + '_Image.dat','Image');
    disp('done');
else
    disp('** Loading image dat: ' + PathToData + DataFile_woext + '_Image.dat');
    load(PathToData + DataFile_woext + '_Image.dat','Image');
    disp('done');
end

[nb_X, nb_Y,nb_Dim] = size(Image);
ih1 = 1.0/(h(1)*h(1));
ih2 = 1.0/(h(2)*h(2));
ih3 = 1.0/(h(3)*h(3));
iHr = ih3*eye(nb_Dim-2, nb_Dim-2);

imshow(Image);

h_Grad= [2 2 1];  // window for Gradient and mean


// norm des norm Gradient
if (use_MeanImage_dat == 1) then
    disp('** Loading nD Mean :' + PathToData + DataFile_woext + '_MeanImage.dat');
    load(PathToData + DataFile_woext + '_MeanImage.dat','MeanImage');
    disp('done');
else
    disp('** Computing nD Mean :' + DataFile);
 
    GradOfMeanImage = zeros(nb_X,nb_Y);
    MeanImage       = zeros(nb_X,nb_Y,nb_Dim);

    dImage = double(Image);

    v = zeros(1,nb_Dim);
    for i=1:nb_X
        // disp( 'i = ' + string(i) + '/' + string(nb_X));
        for j=1:nb_Y
            i_min = i - h_Grad(1) - 1;
            i_max = i + h_Grad(1) + 1;
            if (i_min < 1) then i_min = 1; end
            if (i_max > nb_X) then i_max = nb_X; end
        
            j_min = j - h_Grad(2) - 1;
            j_max = j + h_Grad(2) + 1;
            if (j_min < 1) then j_min = 1; end
            if (j_max > nb_Y) then j_max = nb_Y; end

            MeanImage(i,j,:) = mean(mean(dImage(i_min:i_max,j_min:j_max,:),1),2);
        end 
    end
    
    save(PathToData + DataFile_woext + '_MeanImage.dat','MeanImage');
    disp('done');
end



// GRAD (Mean of variance)
if (use_GradOfMeanImage_dat == 1)  then
    disp('** Loading nD Grad of Mean :' + PathToData + DataFile_woext + '_GradOfMeanImage.dat');
    load(PathToData + DataFile_woext + '_GradOfMeanImage.dat','GradOfMeanImage');
    disp('done');
else
    disp('** Computing nD Grad of Mean :' + DataFile);
    for i=1:nb_X
        //  disp( 'i = ' + string(i) + '/' + string(nb_X));
        for j=1:nb_Y

            i_min = i - h_Grad(1) - 1;
            i_max = i + h_Grad(1) + 1;
            if (i_min < 1) then i_min = 1; end
            if (i_max > nb_X) then i_max = nb_X; end
        
            j_min = j - h_Grad(2) - 1;
            j_max = j + h_Grad(2) + 1;
            if (j_min < 1) then j_min = 1; end
            if (j_max > nb_Y) then j_max = nb_Y; end
        
            n = 0;
            for k=i_min:i_max
                for l=j_min:j_max
                    //for m=1:nb_Dim
                    //    v(m) = MeanImage(k,l,m) - MeanImage(i,j,m);
                    //end
                    v(1,:) = MeanImage(k,l,:) - MeanImage(i,j,:);
                    d2m_r = v * v';   // squared dist mahalanobis range 
                    n     = n + 1;
                    GradOfMeanImage(i,j) = GradOfMeanImage(i,j) + d2m_r;
                end
            end
        GradOfMeanImage(i,j) = sqrt(GradOfMeanImage(i,j)/n);
        end
    end
    save(PathToData + DataFile_woext + '_GradOfMeanImage.dat','GradOfMeanImage');
    disp('done');
end





//PlotImage(GradOfMeanImage*255/max(max(GradOfMeanImage))) ; //,'GradOfMeanImage') ;
disp('*** Histogram of Gradient norm');
// histogramme de GradOfMeanImage
h_GradOfMeanImage = tabul(GradOfMeanImage);
nb_Yi = sum(h_GradOfMeanImage(:,2));

alphaR = (4/(3*nb_Yi))^(1/5);
//h0 = alphaR * iqr( GradOfMeanImage,'r')./1.349 // Pour Gauss
h0 = alphaR * iqr( GradOfMeanImage)./1.349 // Pour Gauss

res_F = 200;
F = ones( res_F, 1);
//delta = max(Y) - min(Y);
//px=linspace( min(Y)-delta/10, max(Y)+delta/10, res_F);
px=linspace( 0, max(h_GradOfMeanImage(:,1)), res_F);
for i=1:res_F,
  F(i) = Parzen_1D_freq( px(i), h_GradOfMeanImage, h0);
end
disp('done');

figure;
plot(px,F, 'r', h_GradOfMeanImage(:,1),h_GradOfMeanImage(:,2)/nb_Yi,'b+');
legend(["pdf" "samples"]);
title("Pdf estimation of the gradient norm image ");


// Selection of Xi (< threshold) and bad_Xi (>threshold)
o_Xi=[grand( nb_Xi , 1 , 'unf', 1, nb_X ), grand( nb_Xi , 1 , 'unf', 1, nb_Y )];

good_Xi = zeros( nb_Xi, nb_Dim+2);
bad_Xi  = zeros( nb_Xi, nb_Dim+2);
good_Xi_True = zeros( nb_Xi, nb_Dim+2);
bad_Xi_True  = zeros( nb_Xi, nb_Dim+2);

nb_good_Xi = 0;
nb_bad_Xi = 0;
for i=1:nb_Xi,
    if GradOfMeanImage(o_Xi(i,1), o_Xi(i,2))<Threshold_Grad then
        nb_good_Xi = nb_good_Xi + 1;
        good_Xi(nb_good_Xi,1) = o_Xi(i,1); // spatial information
        good_Xi(nb_good_Xi,2) = o_Xi(i,2);
        for j=1:nb_Dim
            good_Xi(nb_good_Xi,j+2) = MeanImage( o_Xi(i,1), o_Xi(i,2), j);
            good_Xi_True(nb_good_Xi,j+2) = dImage( o_Xi(i,1), o_Xi(i,2), j);
        end
        
    else
        nb_bad_Xi = nb_bad_Xi + 1;
        bad_Xi(nb_bad_Xi,1) = o_Xi(i,1); // spatial information
        bad_Xi(nb_bad_Xi,2) = o_Xi(i,2);
        for j=1:nb_Dim
            bad_Xi(nb_bad_Xi,j+2) = MeanImage( o_Xi(i,1), o_Xi(i,2), j);
            bad_Xi_True(nb_bad_Xi,j+2) = dImage( o_Xi(i,1), o_Xi(i,2), j);          
        end
        
    end
end

good_Xi = good_Xi(1:nb_good_Xi,:);
bad_Xi  = bad_Xi (1:nb_bad_Xi,:);
good_Xi_True = good_Xi_True(1:nb_good_Xi,:);
bad_Xi_True  = bad_Xi_True (1:nb_bad_Xi,:);
    

// Write in TXT files
if getos() == 'Windows' then unix("del " + PathToSavedData + "_Good_Xi.txt" );
else unix("rm -f"  + PathToSavedData + "_Good_Xi.txt" ); end
write(PathToSavedData + "_Good_Xi.txt", good_Xi_True(:, 3:5) );

if getos() == 'Windows' then unix("del " + PathToSavedData + "_Bad_Xi.txt" );
else unix("rm -f"  + PathToSavedData + "_Bad_Xi.txt" ); end
write(PathToSavedData + "_Bad_Xi.txt",bad_Xi_True(:, 3:5) );
// Color Space

figure;
    param3d1(good_Xi(:,3),good_Xi(:,4),good_Xi(:,5));



    p=get("hdl");
    p.line_mode="off";
    p.mark_mode="on";
    p.mark_style=3;
    p.mark_foreground=2;
    p.mark_background=2;

    param3d1(bad_Xi(:,3),bad_Xi(:,4),bad_Xi(:,5));
    p=get("hdl");
    p.line_mode="off";
    p.mark_mode="on";
    p.mark_style=3;
    p.mark_foreground=5;
    p.mark_background=5;

//Display Xi and Bad_Xi
//figure;
//PlotImage(GradOfMeanImage*255/max(max(GradOfMeanImage)));//,'GradOfMeanImage') ;
GradOfMeanImage_flip = flipdim(GradOfMeanImage', 2);
PlotImage(GradOfMeanImage_flip*255/max(max(GradOfMeanImage)));
// WARNING : ShowImage permutes x and y 
if( size(bad_Xi,1)>0 ) then plot( bad_Xi(:,2) , nb_X-bad_Xi(:,1)+1, 'r+'); end;
if( size(good_Xi,1)>0 ) then plot( good_Xi(:,2) , nb_X-good_Xi(:,1)+1, 'b+'); end;
color_map=['r' 'g' 'c' 'm' 'w' 'b'];


// finding cluster : Clustering good Xi of MeanImage
// Mean Shift ;)
  disp('** MS for Clusters ');
    Y  = good_Xi;
    [nb_Yi nb_Dim] = size(Y);
    Yn = Y;
    SumOfMS = 1;
    i=0;
    while ((i<nb_it_max_ms) & (SumOfMS > eps_ms) )  
        i = i + 1;
        SumOfMS = 0;
        for j=1:nb_Yi,
            Yn(j,:) = DParzen_GG(Y(j,:), Y, h, Trunc_Gauss);
            MS = Yn(j,:) - Y(j,:);
            SumOfMS = SumOfMS + MS*MS';
        end;
      
      Y = Yn;
      SumOfMS = (SumOfMS) / nb_Yi;
      disp('It :'+ string(i) + ' for ' + string(SumOfMS));
    end;  
    Ci = Y;
    
for j=1:nb_Yi,
    plot([Ci(j,2) good_Xi(j,2)], [nb_X-Ci(j,1)+1 nb_X-good_Xi(j,1)+1], 'g');    
end

plot( Ci(:,2) , nb_X-Ci(:,1)+1, 'w*');
    clear Y;
    clear Yn;

// *** point -> Clustering -> Mediods
disp('** Building Cluster');
l_Ci = list();
l_tmp_Ci = list();
l_mediod = list();
iHs_Clustering = [1/(4*h(1)*h(1)) 0; 0 1/(4*h(2)*h(2))];
iHr_Clustering = ( 1/(4*h(3) * h(3)) ) * eye(nb_Dim-2, nb_Dim-2);
// array to list
for i=1:nb_Yi,
    l_tmp_Ci($+1) = Ci(i,:);
end
// 
while( size(l_tmp_Ci) > 0 )
    clear l_mediod;
    l_mediod = list();
    l_mediod(0) = l_tmp_Ci(1);
    l_tmp_Ci(1) = null();
    i = 1;
    while ( i <= size(l_tmp_Ci)),
        x_xi = l_mediod(1) - l_tmp_Ci(i);
//        dxs = x_xi(1:2)*iHs_Clustering*x_xi(1:2)';
        dxr = x_xi(3:nb_Dim)*iHr_Clustering*x_xi(3:nb_Dim)';
        
//        if( (dxs <=1) & (dxr <= 1) ) then    //with spatial
        if( dxr <= 1 ) then                    //without spatial...
            l_mediod($+1) = l_tmp_Ci(i);
            l_tmp_Ci(i) = null();
        else 
            i = i+1;
        end
    end
    l_Ci(0) = l_mediod;
end
clear l_tmp_Ci;
clear l_mediod;

nb_Mi = size(l_Ci);
disp(' *** Number of Medioid ' + string(nb_Mi) );
Mi = zeros(nb_Mi, nb_Dim);
for i=1:nb_Mi
    nb_MiCi = size( l_Ci(i)) ;

    for j=1:nb_MiCi
        Mi(i,:) = Mi(i,:) + l_Ci(i)(j);
    end
    Mi(i,:) = Mi(i,:) / nb_MiCi;
end

//save(PathToSavedData + '_Wi.dat','Wi');

//clear l_Ci;


figure;
    param3d1(Ci(:,3),Ci(:,4),Ci(:,5));
    p=get("hdl");
    p.line_mode="off";
    p.mark_mode="on";
    p.mark_style=1;
    p.mark_foreground=2;
    p.mark_background=2;
   
    param3d1( bad_Xi_True(:,3), bad_Xi_True(:,4), bad_Xi_True(:,5));
    p=get("hdl");
    p.line_mode="off";
    p.mark_mode="on";
    p.mark_style=4;
    p.mark_foreground=5;
    p.mark_background=5;
    
    param3d1( good_Xi_True(:,3), good_Xi_True(:,4), good_Xi_True(:,5));
    p=get("hdl");
    p.line_mode="off";
    p.mark_mode="on";
    p.mark_style=4;
    p.mark_foreground=2;
    p.mark_background=2;

legend(["Ci" "bad Xi" "good Xi"]);

for k=1:nb_Mi    
    param3d1( Mi(k,3),Mi(k,4),Mi(k,5) );
    p=get("hdl");
    p.line_mode="off";
    p.mark_mode="on";
    p.mark_style=3;
    p.mark_foreground=k;
    p.mark_background=1;
end

//    param3d1( bad_Xi(:,3), bad_Xi(:,4), bad_Xi(:,5));
//    p=get("hdl");
//    p.line_mode="off";
//    p.mark_mode="on";
//    p.mark_style=2;
//    p.mark_foreground=5;
//    p.mark_background=2;
    

title("Mediod and Samples");
////////////////////////////////////////////
// filtering 'all points' from Ci
////////////////////////////////////////////

   // Affecting value to unprocessed samples
    hs_filter = h(1:2);
    hr_filter = [h(3), h(3), h(3)];
    iHs_filter = inv(diag(hs_filter.^2));
    iHr_filter = inv(diag(hr_filter.^2));

    fImage = zeros(Image);
    fImageMi = zeros(Image);
    
    d2  = zeros(nb_good_Xi,3);
    for i=1:nb_X,
        for j=1:nb_Y,
            for k=1:nb_good_Xi,
                x_xi = good_Xi_True(k,1:2) - [i,j]; 
                d2xs = x_xi*iHs_filter*x_xi';
           
                //x_xi = good_Xi_True(k,3:5) - [dImage(i,j,1), dImage(i,j,2), dImage(i,j,3)]; 
                x_xi = good_Xi_True(k,3:5) - [MeanImage(i,j,1), MeanImage(i,j,2), MeanImage(i,j,3)]; 
                d2xr = x_xi*iHr_filter*x_xi';
           
                d2(k,:) = [d2xs + d2xr, d2xs, d2xr];              
            end
        
        min_index = find( d2 == min(d2(:,1)) );
        min_index = min_index(1);
    
        fImage(i,j,:) = Ci(min_index,3:5);
     
        tmp_Ci = Ci(min_index, :);
        iMi = 1;
        Mi_stop = 0;
        iMi_min_index = 0;
        while( Mi_stop == 0 & iMi <= size(l_Ci) )   
            jMi = 1;
            while(  Mi_stop == 0 & jMi <= size( l_Ci(iMi) ) )
                x_xi = l_Ci(iMi)(jMi) - tmp_Ci;
                tmp_d2 = x_xi * x_xi';
                if( tmp_d2 == 0 )
                    Mi_stop = 1;
                    iMi_min_index = iMi;
      //              disp(' [' + string(i) + ', ' + string(j) + '] <=> '+ string(iMi_min_index) );
                end
                jMi = jMi + 1;              
            end
            iMi = iMi + 1;
        end
        fImageMi(i,j,:) = Mi(iMi_min_index,3:5);
        
        end
    end

save(PathToSavedData + '_fImage.dat','fImage');
save(PathToSavedData + '_fImageMI.dat','fImageMi');

//figure;
    //ShowColorImage(Image,'Image Original') ;
   // imshow(Image)
// figure;
    //ShowColorImage(uint8(fImage),'Filtered Image ') ;
    imshow(uint8(fImageMi));


    
//////////////////////////////////////////////
//// filtering 'all points' from Mi
//////////////////////////////////////////////
//
// fImageMi = zeros(Image);
//    
//    d2  = zeros(nb_good_Xi,3);
//    for i=1:nb_X,
//        for j=1:nb_Y,
//            for k=1:nb_good_Xi,
//                x_xi = good_Xi_True(k,1:2) - [i,j]; 
//                d2xs = x_xi*iHs_filter*x_xi';
//           
//                x_xi = good_Xi_True(k,3:5) - [dImage(i,j,1), dImage(i,j,2), dImage(i,j,3)]; 
//                d2xr = x_xi*iHr_filter*x_xi';
//           
//                d2(k,:) = [d2xs + d2xr, d2xs, d2xr];              
//            end
//        
//        min_index = find( d2 == min(d2(:,1)) );
//        min_index = min_index(1);
//        tmp_Ci = Ci(min_index, :);
//        
//        iMi = 1;
//        Mi_stop = 0;
//        iMi_min_index = 0;
//        while( Mi_stop == 0 & iMi <= size(l_Ci) )   
//            jMi = 1;
//            while(  Mi_stop == 0 & jMi <= size( l_Ci(iMi) ) )
//                x_xi = l_Ci(iMi)(jMi) - tmp_Ci;
//                tmp_d2 = x_xi * x_xi';
//                if( tmp_d2 == 0 )
//                    Mi_stop = 1;
//                    iMi_min_index = iMi;
//      //              disp(' [' + string(i) + ', ' + string(j) + '] <=> '+ string(iMi_min_index) );
//                end
//                jMi = jMi + 1;              
//            end
//            iMi = iMi + 1;
//        end
//        fImageMi(i,j,:) = Mi(iMi_min_index,3:5);
//        end
//    end
//



//figure;
    //ShowColorImage(Image,'Image Original') ;
   // imshow(Image)
// figure;
    //ShowColorImage(uint8(fImage),'Filtered Image ') ;
    imshow(uint8(fImageMi));
