function [Image, fGMSImage, fGBMSImage]=Ex_GMS_f_RGBImage(path_to_rgbimage, nb_Xi )
// [I,Igms, Igbms] = Ex_GMS_f_RGBImage('E:\Creatis\Creatis_CVS\Grenier\Scilab\Data\R-G-B64_ColorImage_blurred15_3_sd30_norm.png',500);

hs = [3 3]; 
hr = [20 20 20]; // RGB image 
eps_ms = 0.1; // 0.1
max_iter = 30;

//     nb_Xi = 600; //1000
//     Image = imread('C:\Creatis\Creatis_CVS\Grenier\Scilab\Data\R-G-B64_ColorImage_blurred15_3_sd30_norm.png');

     Image = imread(path_to_rgbimage);
       
     // preparing samples
      disp('** Preparing samples');
     dImage = double(Image);
     [nb_X, nb_Y, nb_Dim] = size(dImage);
      Xi = zeros( nb_X*nb_Y, nb_Dim+2);
      c = 1;
      for i=1:nb_X,
          for j=1:nb_Y,
              Xi(c,1) = i; // spatial information
              Xi(c,2) = j;
              for k=1:nb_Dim
                  Xi(c,k+2) = dImage( i, j, k);
              end
              c = c + 1;
          end          
      end
          
    // filtering
        disp('** Filtering GMS');
     [GMSAs, GMSAr] = GMS_f( nb_Xi, Xi(:,1:2), Xi(:,3:5), hs, hr, eps_ms, max_iter);
    
    // creating image
     disp('** Building filtered image GMS');
     fGMSImage = zeros(dImage);
     c = 1;
      for i=1:nb_X,
          for j=1:nb_Y,
              fGMSImage(i,j,:) = GMSAr(c,:);
              c = c + 1;
          end          
      end
  
      // filtering
        disp('** Filtering GBMS');
     [GBMSAs, GBMSAr] = GBMS_f( nb_Xi, Xi(:,1:2), Xi(:,3:5), hs, hr, eps_ms, max_iter);
    
    // creating image
    disp('** Building filtered image GBMS');
     fGBMSImage = zeros(dImage);
     c = 1;
      for i=1:nb_X,
          for j=1:nb_Y,
              fGBMSImage(i,j,:) = GBMSAr(c,:);
              c = c + 1;
          end          
      end
    
      disp('** Displaying results');
//    figure;
//    ShowColorImage(Image,'Image Original') ;
//    imshow(Image)
    
//    figure;
//    ShowColorImage(uint8(fGMSImage),'Image GMS_f') ;
//    imshow(uint8(fGMSImage));

//    figure;
//    ShowColorImage(uint8(fGBMSImage),'Image GBMS_f') ;
//   imshow(uint8(fGBMSImage));
   
endfunction
