function k = Ke(x)
  [d tmp] = size(x); 
  xx = x'*x;
  if xx > 1 then 
    k = 0;
  else
    k = (gamma(d/2)*d*(d+2)/( 4*(%pi^(d/2)) )) * (1 - xx);
  end
endfunction


function s = RKe1(eps)
s=0;
nb=0;
for i=-1:eps:1,
  kk = Ke(i);
  if kk > 0 then
    nb = nb + 1;
    s = s + kk*kk;
  end
end
s=s*eps;
endfunction

function s = MuKe1(eps)
s=0;
nb=0;
for i=-1:eps:1,
  kk = Ke(i);
  if kk > 0 then
    nb = nb + 1;
    s = s + i*i*kk;
  end
end
s=s*eps;
endfunction

function s = RKe2(eps)
s=0;
nb=0;
for i=-1:eps:1,
  for j=-1:eps:1,
   kk = Ke([i;j]);
   if kk > 0 then
      nb = nb + 1;
      s = s + kk*kk;
   end
  end
end
s=s*eps*eps;
endfunction


function s = MuKe2(eps)
s=zeros(2,2);
nb=0;
for i=-1:eps:1,
  for j=-1:eps:1,
   ij = [i;j];
   kk = Ke(ij);
    if kk > 0 then
      nb = nb + 1;
      s = s + ij*ij'*kk;
    end
  end
end
s=s*eps*eps;
endfunction

function s = RKe3(eps)
s=0;
nb=0;
for i=-1:eps:1,
  printf("*");
end
printf("\n");
for i=-1:eps:1,
  printf("*");
  for j=-1:eps:1,
     for k=-1:eps:1,
        kk = Ke([i;j;k]);
        if kk > 0 then
          nb = nb + 1;
          s = s + kk*kk;
        end
      end
  end
end
printf("\n");
s=s*eps*eps*eps;
endfunction

function s = MuKe3(eps)
s=zeros(3,3);
nb=0;
for i=-1:eps:1,
  printf("*");
end
printf("\n");
for i=-1:eps:1,
  printf("*");
  for j=-1:eps:1,
      for k=-1:eps:1,
        ijk = [i;j;k];
        kk = Ke(ijk);
        if kk > 0 then
         nb = nb + 1;
         s = s + ijk*ijk'*kk; //general eq.
//         s = s + i*i*kk; // true for spherically symmetric compactly supported probability densities 
                      // and product kernels based on compactly supported symmetric univariate densities
         
        end
     end
  end
end
printf("\n");
s=s*eps*eps*eps;
endfunction
