function [fx]=Parzen_EG(X,Xi,h)
// Xi : echantillon des donnes : matrice
// X  : point o raliser l'estimation
// fx : estimation au point X


PI=3.141592;
[nb_Xi,nb_Dim] = size(Xi); 


// Profile Gaussien
function [y]=k_gauss(x)
y = exp(-x/2) / sqrt(2*PI);
endfunction


// Profile Epanechnikov
function [y]=k_epan(x)
if abs(x) < 1 then
  y = 3*(1-x)/4;
 else
  y = 0;
end
endfunction

// Profile Rectangle
function [y]=k_rect(x)
if abs(x)>1 then
  y = 0;
  else
  y = 1/2 ;
end
endfunction

fx=0;
for i = 1:nb_Xi,
  x_xi = X  - Xi(i,:);
  dxs = x_xi(1)*x_xi(1)/(h(1)*h(1)) + x_xi(2)*x_xi(2)/(h(2)*h(2));
  dxr = x_xi(3)*x_xi(3)/(h(3)*h(3));
  fx= fx + k_epan( dxs ) * k_gauss( dxr );
end

fx = fx / (nb_Xi * h(3));
//fx = fx / (nb_Xi * h(1)* h(2)* h(3));
endfunction

